#include "config.h"

#include <sstream>
#include <string>

#include "QueryResults.hh"

namespace diskCache
{
  QueryResults::
  QueryResults( format_type Format, type_type Type )
    : m_format( Format ),
      m_type( Type )
  {
  }

  const std::string& QueryResults::
  formatString( ) const
  {
    static const std::string	format_unknown( "FORMAT_UNKNOWN" );

    static const std::string	format_tcl( "FORMAT_TCL" );

    switch( format( ) )
    {
    case FORMAT_TCL:
      return format_tcl;
    default:
      return format_unknown;
    }
  }

  void QueryResults::
  tcl_make_list( std::string& Data ) const
  {
    const char* data_end( ( Data.length( ) > 0 ) ? " }" : "}" );

    Data.insert( 0, "{ " );
    Data.append( data_end );
  }

  void QueryResults::
  tcl_list_begin( std::ostringstream& Stream ) const
  {
    if ( Stream.str( ).length( ) != 0 )
    {
      Stream << " ";
    }
    Stream << "{";
  }

  void QueryResults::
  tcl_list_begin( std::string& String ) const
  {
    if ( String.length( ) != 0 )
    {
      String += " ";
    }
    String += "{";
  }

  void QueryResults::
  tcl_list_end( std::ostringstream& Stream ) const
  {
    Stream << " }";
  }

  void QueryResults::
  tcl_list_end( std::string& String ) const
  {
    String += " }";
  }
}
