#!/usr/bin/env perl
$pending_block = "";
sub postprocess()
{
    my($new_pending_block) = "";
    my($stage) = 0;
    foreach ( split '\n', $pending_block )
    {
	s,//:,/// \\brief,;
	s,//[+],///,;
	s,//\s*!param:(.*)\s+([A-Za-z_0-9]+)\s*-,/// \\param[in] $2,;
	s,//\s*!return:(.*-),/// \\return,;
	s,//\s*!exc:,/// \\exception,;
	
	if ( $stage == 0 )
	{
	    if ( /^\s*\/\/+\s*$/ )
	    {
		next;
    	    }
	    else
	    {
		$stage = 1;
	    }
	}
	elsif ( $stage == 1 )
	{
	    if ( /^\s*\/\/+[-]+\s*$/ )
	    {
		if ($stage == 1)
		{
		    $stage = 0;
		}
	    }
	}
	$new_pending_block .= "$_\n";
    }
    $pending_block = $new_pending_block;
}

sub pack($)
{
    my($line) = @_;

    if ( $line =~ /^\s*\/\// )
    {
	$pending_block = $pending_block . "$line\n";
    }
    else
    {
	postprocess;
	print "$pending_block$line\n";
	$pending_block = "";
    }
}

$con = 0;
$ignore = 0;
while ( <> )
{
    chop;

    #--------------------------------------------------------------------
    # Remove lines only intended for visual effects
    #--------------------------------------------------------------------
    s,^\s*///(-|=)+$^\s*,,m;

    &pack($_);
}
