#ifndef FrameCPP_VERSION_3_FrEndOfFile_HH
#define FrameCPP_VERSION_3_FrEndOfFile_HH

#include "general/types.hh"

#include "framecpp/Version3/FrameSpec.hh"

#include "framecpp/Common/FrEndOfFile.hh"
#include "framecpp/Common/Verify.hh"

namespace FrameCPP
{
  namespace Version_3
  {
    class FrEndOfFile
      : public Common::FrEndOfFile
    {
    public:
      typedef INT_4U nFrames_type;
      typedef INT_4U nBytes_type;
      typedef INT_4U chkFlag_type;
      typedef INT_4U chkSum_type;

      FrEndOfFile( );
      virtual ~FrEndOfFile( );

      static const char* const StructName( );

      static const Common::Description* StructDescription( );

      virtual Common::FrameSpec::size_type
      Bytes( const Common::StreamBase& Stream ) const;

      virtual FrEndOfFile* Create( Common::IStream& Stream ) const;

      virtual const char* const ObjectStructName( ) const;

      virtual void Write( Common::OStream& Stream ) const;

      /// \brief comparison operator
      bool operator==( const FrEndOfFile& RHS ) const;

      /// \brief comparison operator
      virtual bool operator==( const Common::FrameSpec::Object& Obj ) const;

      static const Common::FrameSpec::Info::frame_object_types s_object_id
      = Common::FrameSpec::Info::FSI_FR_END_OF_FILE;

      virtual FrEndOfFile::seekTOC_cmn_type SeekTOC( ) const;

      virtual void VerifyObject( Common::Verify& Verifier,
				 Common::IFrameStream& Stream ) const;

    protected:
      nFrames_type	m_nFrames;
      nBytes_type	m_nBytes;
      chkFlag_type	m_chkFlag;
      chkSum_type	m_chkSum;

      /// \brief Down grade an object
      virtual std::auto_ptr< Object > demote( INT_2U Target, Common::IStream* Stream ) const;

      /// \brief Upgrade an object
      virtual std::auto_ptr< Object > promote( INT_2U Target, Object* Obj, Common::IStream* Stream ) const;

    private:
      using Common::FrameSpec::Object::Create;

      FrEndOfFile( Common::IStream& Source );

    }; // class - FrEndOfFile

    inline const char* const FrEndOfFile::
    StructName( )
    {
      static const CHAR* class_name( "FrEndOfFile" );
      return class_name;
    }

    inline Common::FrEndOfFile::seekTOC_cmn_type FrEndOfFile::
    SeekTOC( ) const
    {
      return 0;
    }
  } // namespace - Version_3
} // namespace - FrameCPP

#endif /* FrameCPP_VERSION_3_FrEndOfFile_HH */
