#ifndef GENERAL__FORK_HH
#define GENERAL__FORK_HH

#include <sys/types.h>
#include <unistd.h>

namespace General
{
  class Fork
  {
  public:
    Fork( );
    virtual ~Fork( );
    pid_t ChildPid( ) const;

    void Spawn( );
  protected:
    virtual void evalChild( ) = 0;
    virtual void evalParent( ) = 0;

    int getReadFD( ) const;
    int	getWriteFD( ) const;
    bool isParent( ) const;

  private:
    pid_t	m_child_pid;
    int		m_pipes[2][2];

    void close_pipes( );
    void close_pipe( int Major, int Minor );
  };

  inline pid_t Fork::
  ChildPid( ) const
  {
    return m_child_pid;
  }

  inline bool Fork::
  isParent( ) const
  {
    return ( m_child_pid != 0 );
  }

  inline int Fork::
  getReadFD( ) const
  {
    return ( isParent( ) )
      ? m_pipes[ 0 ][ 0 ]
      : m_pipes[ 1 ][ 0 ];
  }

  inline int Fork::
  getWriteFD( ) const
  {
    return ( isParent( ) )
      ? m_pipes[ 1 ][ 1 ]
      : m_pipes[ 0 ][ 1 ];
  }

}

#endif /* GENERAL__TIMEOUT_HH */

